<?php
class ModelExtensionModuleCustomerWishlist extends Model {
	public function addWishlist($customer_id, $product_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "customer_wishlist WHERE customer_id = '" . (int)$customer_id . "' AND product_id = '" . (int)$product_id . "'");

		$this->db->query("INSERT INTO " . DB_PREFIX . "customer_wishlist SET customer_id = '" . (int)$customer_id . "', product_id = '" . (int)$product_id . "', date_added = NOW()");
	}

	public function deleteWishlist($customer_id, $product_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "customer_wishlist WHERE customer_id = '" . (int)$customer_id . "' AND product_id = '" . (int)$product_id . "'");
	}

	public function getWishlist($customer_id) {
        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "customer_wishlist WHERE customer_id = '" . (int)$customer_id . "'");

		return $query->rows;
	}

	public function getTotalWishlist($customer_id) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "customer_wishlist WHERE customer_id = '" . (int)$customer_id . "'");

		return $query->row['total'];
	}
	
	public function getAllWishlist() {
        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "customer_wishlist");

		return $query->rows;
	}

	    public function getAllWishlistFiltered($filter) {
        $sql = "SELECT * FROM " . DB_PREFIX . "customer_wishlist";

        if (isset($filter['sort'])) {
            $sql .= " ORDER BY " . $filter['sort'];
        }else {
            $sql .= " ORDER BY customer_id";
        }
        if (isset($filter['order'])) {
            $sql .= " " . $filter['order'];
        }else {
            $sql .= " ASC";
        }

        if (isset($filter['start']) || isset($filter['limit'])) {
            if ($filter['start'] < 0) {
                $filter['start'] = 0;
            }

            if ($filter['limit'] < 1) {
                $filter['limit'] = 100;
            }

            $sql .= " LIMIT " . (int)$filter['start'] . "," . (int)$filter['limit'];
        }
        $query = $this->db->query("$sql");

        return $query->rows;
    }
}
